// udosh32Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "udosh32.h"
#include "udosh32Dlg.h"
#include "ConfigDlg.h"
#include <direct.h>

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	CString	m_version;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	m_version = _T("");
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	DDX_Text(pDX, IDC_VERSION, m_version);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUdosh32Dlg dialog

CUdosh32Dlg::CUdosh32Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUdosh32Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUdosh32Dlg)
	m_use_dir = FALSE;
	m_use_hyp = FALSE;
	m_use_log = FALSE;
	m_use_sym1 = FALSE;
	m_use_sym2 = FALSE;
	m_use_sym3 = FALSE;
	m_use_sym4 = FALSE;
	m_use_sym5 = FALSE;
	m_use_sym6 = FALSE;
	m_use_test = FALSE;
	m_use_tree = FALSE;
	m_use_verb = FALSE;
	m_symbol1 = _T("");
	m_symbol2 = _T("");
	m_symbol3 = _T("");
	m_symbol4 = _T("");
	m_symbol5 = _T("");
	m_symbol6 = _T("");
	m_file_dest = _T("");
	m_file_final = _T("");
	m_file_param = _T("");
	m_file_source = _T("");
	m_hold_key = FALSE;
	m_warnings = FALSE;
	m_format = -1;
	m_file_param2 = _T("");
	m_use_check = FALSE;
	m_use_map_gfa = FALSE;
	m_use_map_pas = FALSE;
	m_use_map_vb = FALSE;
	m_always_on_top = FALSE;
	m_use_upr = FALSE;
	//}}AFX_DATA_INIT

	//-dh-
	strcpy(m_charIni, "");
	m_file_log = "";
	m_file_hyp = "";
	m_file_tree = "";

	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUdosh32Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUdosh32Dlg)
	DDX_Check(pDX, IDC_CHECK_DIR, m_use_dir);
	DDX_Check(pDX, IDC_CHECK_HYP, m_use_hyp);
	DDX_Check(pDX, IDC_CHECK_LOG, m_use_log);
	DDX_Check(pDX, IDC_CHECK_SYM1, m_use_sym1);
	DDX_Check(pDX, IDC_CHECK_SYM2, m_use_sym2);
	DDX_Check(pDX, IDC_CHECK_SYM3, m_use_sym3);
	DDX_Check(pDX, IDC_CHECK_SYM4, m_use_sym4);
	DDX_Check(pDX, IDC_CHECK_SYM5, m_use_sym5);
	DDX_Check(pDX, IDC_CHECK_SYM6, m_use_sym6);
	DDX_Check(pDX, IDC_CHECK_TEST, m_use_test);
	DDX_Check(pDX, IDC_CHECK_TREE, m_use_tree);
	DDX_Check(pDX, IDC_CHECK_VERB, m_use_verb);
	DDX_Text(pDX, IDC_EDIT_SYM1, m_symbol1);
	DDX_Text(pDX, IDC_EDIT_SYM2, m_symbol2);
	DDX_Text(pDX, IDC_EDIT_SYM3, m_symbol3);
	DDX_Text(pDX, IDC_EDIT_SYM4, m_symbol4);
	DDX_Text(pDX, IDC_EDIT_SYM5, m_symbol5);
	DDX_Text(pDX, IDC_EDIT_SYM6, m_symbol6);
	DDX_Text(pDX, IDC_FILE_DEST, m_file_dest);
	DDX_Text(pDX, IDC_FILE_FINAL, m_file_final);
	DDX_Text(pDX, IDC_FILE_PARAM, m_file_param);
	DDX_Text(pDX, IDC_FILE_SOURCE, m_file_source);
	DDX_Check(pDX, IDC_CHECK_KEY, m_hold_key);
	DDX_Check(pDX, IDC_CHECK_WARN, m_warnings);
	DDX_CBIndex(pDX, IDC_COMBO_FORMAT, m_format);
	DDX_Text(pDX, IDC_FILE_PARAM2, m_file_param2);
	DDX_Check(pDX, IDC_CHECK_CHECK, m_use_check);
	DDX_Check(pDX, IDC_CHECK_MAP_GFA, m_use_map_gfa);
	DDX_Check(pDX, IDC_CHECK_MAP_PAS, m_use_map_pas);
	DDX_Check(pDX, IDC_CHECK_MAP_VB, m_use_map_vb);
	DDX_Check(pDX, IDC_CHECK_AOT, m_always_on_top);
	DDX_Check(pDX, IDC_CHECK_UPR, m_use_upr);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUdosh32Dlg, CDialog)
	//{{AFX_MSG_MAP(CUdosh32Dlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CREATE()
	ON_BN_CLICKED(IDC_CHOOSE_SOURCE, OnChooseSource)
	ON_BN_CLICKED(IDC_CHOOSE_DEST, OnChooseDest)
	ON_BN_CLICKED(IDC_EDIT_SOURCE, OnEditSource)
	ON_BN_CLICKED(IDC_EDIT_DEST, OnEditDest)
	ON_BN_CLICKED(IDC_EDIT_PARAM, OnEditParam)
	ON_BN_CLICKED(IDC_EDIT_FINAL, OnEditFinal)
	ON_BN_CLICKED(IDC_EXEC_SOURCE, OnExecSource)
	ON_BN_CLICKED(IDC_EXEC_DEST, OnExecDest)
	ON_BN_CLICKED(IDC_EXEC_PARAM, OnExecParam)
	ON_BN_CLICKED(IDC_EXEC_FINAL, OnExecFinal)
	ON_BN_CLICKED(IDC_BUTTON_LOG, OnButtonLog)
	ON_BN_CLICKED(IDC_BUTTON_HYP, OnButtonHyp)
	ON_BN_CLICKED(IDC_BUTTON_TREE, OnButtonTree)
	ON_BN_CLICKED(IDC_CHECK_DIR, OnCheckDir)
	ON_BN_CLICKED(IDC_BUTTON_INFO, OnButtonInfo)
	ON_BN_CLICKED(IDC_BUTTON_HELP, OnButtonHelp)
	ON_BN_CLICKED(IDC_BUTTON_CONFIG, OnButtonConfig)
	ON_CBN_SELENDOK(IDC_COMBO_FORMAT, OnSelendokComboFormat)
	ON_BN_CLICKED(IDC_EDIT_PARAM2, OnEditParam2)
	ON_BN_CLICKED(IDC_EXEC_PARAM2, OnExecParam2)
	ON_BN_CLICKED(IDC_BUTTON_MAP_PAS, OnButtonMapPas)
	ON_BN_CLICKED(IDC_BUTTON_MAP_GFA, OnButtonMapGfa)
	ON_BN_CLICKED(IDC_BUTTON_MAP_VB, OnButtonMapVb)
	ON_BN_CLICKED(IDC_CHECK_AOT, OnCheckAot)
	ON_BN_CLICKED(IDC_BUTTON_UPR, OnButtonUpr)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUdosh32Dlg message handlers

//-dh- Konstanten
#define	TOASC	0
#define	TOWIN	1
#define	TOWH4	2
#define	TOHTM	3
#define	TOMHH	4
#define	TORTF	5

#define	TOTEX	6
#define TOPDF	7
#define	TOINF	8
#define	TOMAN	9
#define	TOSTG	10
#define	TOPCH	11

#define	TOTVH	12
#define	TOLDS	13
#define	TOAQV	14
#define	TODRC	15
#define	TOIPF	16
#define	TOLYX	17

#define	TONRO	18
#define	TOSRC	19
#define	TOSRP	20
#define	TOUDO	21
#define	TOKPS	22
#define	TOAMG	23

#define	TOMAX	24


BOOL CUdosh32Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	//-dh-
	// Bug von VC4 umgehen, so da "maximieren" und
	// "Gre ndern" im Men nicht anwhlbar ist
	pSysMenu->EnableMenuItem(SC_MAXIMIZE, MF_GRAYED);
	pSysMenu->EnableMenuItem(SC_SIZE, MF_GRAYED);

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	//-dh-
	CComboBox* pList= (CComboBox *) GetDlgItem(IDC_COMBO_FORMAT);
	pList->ResetContent();
	pList->AddString("ASCII");
	pList->AddString("WinHelp");
	pList->AddString("WinHelp4");
	pList->AddString("HTML");
	pList->AddString("HTML Help");
	pList->AddString("RTF");
	pList->AddString("LaTeX");
	pList->AddString("PDFLaTeX");
	pList->AddString("Texinfo");
	pList->AddString("Manpage");
	pList->AddString("ST-Guide");
	pList->AddString("Pure C Help");
	pList->AddString("Turbo Vision Help");
	pList->AddString("Linuxdoc SGML");
	pList->AddString("Apple Quickview");
	pList->AddString("DRC");
	pList->AddString("OS/2 IPF");
	pList->AddString("LyX");
	pList->AddString("NROFF");
	pList->AddString("C");
	pList->AddString("Pascal");
	pList->AddString("UDO");
	pList->AddString("PostScript");
	pList->AddString("AmigaGuide");
	pList->SetCurSel(m_format);

	adjust_files();
	adjust_buttons();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CUdosh32Dlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.m_version= __UDOVERSION__;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUdosh32Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUdosh32Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}




void CUdosh32Dlg::write_format_data ( FormatData *pFD, const char *key, const char *ini )
{
	const char *sTRUE= "TRUE";
	const char *sFALSE= "FALSE";

	WritePrivateProfileString(key, "DestSuf",		pFD->DestSuf, ini);
	WritePrivateProfileString(key, "DestApp",		pFD->DestApp, ini);
	WritePrivateProfileString(key, "DestEdi",		pFD->DestEdi, ini);
	WritePrivateProfileString(key, "DestLower",		(pFD->DestLower) ? sTRUE : sFALSE, ini);
	WritePrivateProfileString(key, "DestUnix",		(pFD->DestUnix) ? sTRUE : sFALSE, ini);

	WritePrivateProfileString(key, "ParamSuf",		pFD->ParamSuf, ini);
	WritePrivateProfileString(key, "ParamApp",		pFD->ParamApp, ini);
	WritePrivateProfileString(key, "ParamEdi",		pFD->ParamEdi, ini);
	WritePrivateProfileString(key, "ParamLower",	(pFD->ParamLower) ? sTRUE : sFALSE, ini);
	WritePrivateProfileString(key, "ParamUnix",		(pFD->ParamUnix) ? sTRUE : sFALSE, ini);

	WritePrivateProfileString(key, "Param2Suf",		pFD->Param2Suf, ini);
	WritePrivateProfileString(key, "Param2App",		pFD->Param2App, ini);
	WritePrivateProfileString(key, "Param2Edi",		pFD->Param2Edi, ini);
	WritePrivateProfileString(key, "Param2Lower",	(pFD->Param2Lower) ? sTRUE : sFALSE, ini);
	WritePrivateProfileString(key, "Param2Unix",	(pFD->Param2Unix) ? sTRUE : sFALSE, ini);

	WritePrivateProfileString(key, "FinalSuf",		pFD->FinalSuf, ini);
	WritePrivateProfileString(key, "FinalApp",		pFD->FinalApp, ini);
	WritePrivateProfileString(key, "FinalEdi",		pFD->FinalEdi, ini);
	WritePrivateProfileString(key, "FinalLower",	(pFD->FinalLower) ? sTRUE : sFALSE, ini);
	WritePrivateProfileString(key, "FinalUnix",		(pFD->FinalUnix) ? sTRUE : sFALSE, ini);
}


BOOL CUdosh32Dlg::DestroyWindow() 
{
	char val[32];
	const char *sTRUE= "TRUE";
	const char *sFALSE= "FALSE";
	const char *sShell= "Shell";

	UpdateData(TRUE);

	SetIniFilename();

	WritePrivateProfileString(sShell, "Source", m_file_source, m_charIni);
	WritePrivateProfileString(sShell, "Destination", m_file_dest, m_charIni);

	WritePrivateProfileString(sShell, "UseLog",			(m_use_log)			? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseCheck",		(m_use_check)		? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseHyp",			(m_use_hyp)			? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseTree",		(m_use_tree)		? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseUPR",			(m_use_upr)			? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseMapPas",		(m_use_map_pas)		? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseMapGFA",		(m_use_map_gfa)		? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseMapVB",		(m_use_map_vb)		? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseDir",			(m_use_dir)			? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseVerbose",		(m_use_verb)		? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseTest",		(m_use_test)		? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseHold",		(m_hold_key)		? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseWarnings",	(m_warnings)		? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "AlwaysOnTop",	(m_always_on_top)	? sTRUE : sFALSE, m_charIni);

	WritePrivateProfileString(sShell, "UseSymbol1", (m_use_sym1) ? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseSymbol2", (m_use_sym2) ? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseSymbol3", (m_use_sym3) ? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseSymbol4", (m_use_sym4) ? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseSymbol5", (m_use_sym5) ? sTRUE : sFALSE, m_charIni);
	WritePrivateProfileString(sShell, "UseSymbol6", (m_use_sym6) ? sTRUE : sFALSE, m_charIni);

	WritePrivateProfileString(sShell, "Symbol1", m_symbol1, m_charIni);
	WritePrivateProfileString(sShell, "Symbol2", m_symbol2, m_charIni);
	WritePrivateProfileString(sShell, "Symbol3", m_symbol3, m_charIni);
	WritePrivateProfileString(sShell, "Symbol4", m_symbol4, m_charIni);
	WritePrivateProfileString(sShell, "Symbol5", m_symbol5, m_charIni);
	WritePrivateProfileString(sShell, "Symbol6", m_symbol6, m_charIni);

	itoa(m_format, val, 10);
	WritePrivateProfileString(sShell, "Format", val, m_charIni);

	WritePrivateProfileString("UDO", "App", m_app_udo, m_charIni);
	WritePrivateProfileString("UDO", "Edi", m_edi_udo, m_charIni);

	write_format_data(&m_fd_ASC, "ASCII",			m_charIni);
	write_format_data(&m_fd_WIN, "WinHelp",			m_charIni);
	write_format_data(&m_fd_WH4, "WH4",				m_charIni);
	write_format_data(&m_fd_RTF, "RTF",				m_charIni);
	write_format_data(&m_fd_HTM, "HTML",			m_charIni);
	write_format_data(&m_fd_MHH, "HTML-Help",		m_charIni);
	write_format_data(&m_fd_TEX, "LaTeX",			m_charIni);
	write_format_data(&m_fd_PDF, "PDFLaTeX",		m_charIni);
	write_format_data(&m_fd_INF, "Texinfo",			m_charIni);
	write_format_data(&m_fd_MAN, "Manpage",			m_charIni);
	write_format_data(&m_fd_STG, "ST-Guide",		m_charIni);
	write_format_data(&m_fd_PCH, "Pure-C",			m_charIni);
	write_format_data(&m_fd_TVH, "Turbo-Vision",	m_charIni);
	write_format_data(&m_fd_LDS, "Linuxdoc",		m_charIni);
	write_format_data(&m_fd_AQV, "QuickView",		m_charIni);
	write_format_data(&m_fd_DRC, "DRC",				m_charIni);
	write_format_data(&m_fd_IPF, "IPF",				m_charIni);
	write_format_data(&m_fd_NRO, "nroff",			m_charIni);
	write_format_data(&m_fd_LYX, "LyX",				m_charIni);
	write_format_data(&m_fd_SRC, "C",				m_charIni);
	write_format_data(&m_fd_SRP, "Pascal",			m_charIni);
	write_format_data(&m_fd_UDO, "udo2udo",			m_charIni);
	write_format_data(&m_fd_KPS, "PS",				m_charIni);
	write_format_data(&m_fd_AMG, "AmigaGuide",		m_charIni);

	return CDialog::DestroyWindow();
}


void CUdosh32Dlg::read_format_data ( FormatData *pFD, const char *key, const char *ini )
{
	char s[512];
	const char *sTRUE= "TRUE";
	const char *sFALSE= "FALSE";

	SetIniFilename();

	GetPrivateProfileString(key, "DestApp", "", (LPSTR) s, 512, m_charIni);			pFD->DestApp= s;
	GetPrivateProfileString(key, "DestEdi", "", (LPSTR) s, 512, m_charIni);			pFD->DestEdi= s;
	GetPrivateProfileString(key, "DestSuf", "", (LPSTR) s, 512, m_charIni);			pFD->DestSuf= s;
	GetPrivateProfileString(key, "DestLower", sFALSE, (LPSTR) s, 512, m_charIni);	pFD->DestLower= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(key, "DestUnix", sFALSE, (LPSTR) s, 512, m_charIni);	pFD->DestUnix= (stricmp(s, sTRUE)==0);


	GetPrivateProfileString(key, "ParamApp", "", (LPSTR) s, 512, m_charIni);		pFD->ParamApp= s;
	GetPrivateProfileString(key, "ParamEdi", "", (LPSTR) s, 512, m_charIni);		pFD->ParamEdi= s;
	GetPrivateProfileString(key, "ParamSuf", "", (LPSTR) s, 512, m_charIni);		pFD->ParamSuf= s;
	GetPrivateProfileString(key, "ParamLower", sFALSE, (LPSTR) s, 512, m_charIni);	pFD->ParamLower= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(key, "ParamUnix", sFALSE, (LPSTR) s, 512, m_charIni);	pFD->ParamUnix= (stricmp(s, sTRUE)==0);


	GetPrivateProfileString(key, "Param2App", "", (LPSTR) s, 512, m_charIni);		pFD->Param2App= s;
	GetPrivateProfileString(key, "Param2Edi", "", (LPSTR) s, 512, m_charIni);		pFD->Param2Edi= s;
	GetPrivateProfileString(key, "Param2Suf", "", (LPSTR) s, 512, m_charIni);		pFD->Param2Suf= s;
	GetPrivateProfileString(key, "Param2Lower", sFALSE, (LPSTR) s, 512, m_charIni);	pFD->Param2Lower= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(key, "Param2Unix", sFALSE, (LPSTR) s, 512, m_charIni);	pFD->Param2Unix= (stricmp(s, sTRUE)==0);


	GetPrivateProfileString(key, "FinalApp", "", (LPSTR) s, 512, m_charIni);		pFD->FinalApp= s;
	GetPrivateProfileString(key, "FinalEdi", "", (LPSTR) s, 512, m_charIni);		pFD->FinalEdi= s;
	GetPrivateProfileString(key, "FinalSuf", "", (LPSTR) s, 512, m_charIni);		pFD->FinalSuf= s;
	GetPrivateProfileString(key, "FinalLower", sFALSE, (LPSTR) s, 512, m_charIni);	pFD->FinalLower= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(key, "FinalUnix", sFALSE, (LPSTR) s, 512, m_charIni);	pFD->FinalUnix= (stricmp(s, sTRUE)==0);
}

int CUdosh32Dlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	char s[512], *ptr;
	const char *sTRUE= "TRUE";
	const char *sFALSE= "FALSE";
	const char *sShell= "Shell";
	size_t sl;

	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	SetIniFilename();

	GetPrivateProfileString(sShell, "Source", "", (LPSTR) s, 512, m_charIni);			m_file_source= s;
	GetPrivateProfileString(sShell, "Destination", "", (LPSTR) s, 512, m_charIni);		m_file_dest= s;

	GetPrivateProfileString(sShell, "UseLog", sFALSE, (LPSTR) s, 512, m_charIni);		m_use_log= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseCheck", sFALSE, (LPSTR) s, 512, m_charIni);		m_use_check= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseHyp", sFALSE, (LPSTR) s, 512, m_charIni);		m_use_hyp= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseTree", sFALSE, (LPSTR) s, 512, m_charIni);		m_use_tree= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseUPR", sFALSE, (LPSTR) s, 512, m_charIni);		m_use_upr= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseMapPas", sFALSE, (LPSTR) s, 512, m_charIni);	m_use_map_pas= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseMapGFA", sFALSE, (LPSTR) s, 512, m_charIni);	m_use_map_gfa= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseMapVB", sFALSE, (LPSTR) s, 512, m_charIni);		m_use_map_vb= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseTest", sFALSE, (LPSTR) s, 512, m_charIni);		m_use_test= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseHold", sFALSE, (LPSTR) s, 512, m_charIni);		m_hold_key= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseDir", sFALSE, (LPSTR) s, 512, m_charIni);		m_use_dir= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseVerbose", sFALSE, (LPSTR) s, 512, m_charIni);	m_use_verb= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseWarnings", sFALSE, (LPSTR) s, 512, m_charIni);	m_warnings= (stricmp(s, sTRUE)==0);

	GetPrivateProfileString(sShell, "UseSymbol1", sFALSE, (LPSTR) s, 512, m_charIni);	m_use_sym1= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseSymbol2", sFALSE, (LPSTR) s, 512, m_charIni);	m_use_sym2= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseSymbol3", sFALSE, (LPSTR) s, 512, m_charIni);	m_use_sym3= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseSymbol4", sFALSE, (LPSTR) s, 512, m_charIni);	m_use_sym4= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseSymbol5", sFALSE, (LPSTR) s, 512, m_charIni);	m_use_sym5= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "UseSymbol6", sFALSE, (LPSTR) s, 512, m_charIni);	m_use_sym6= (stricmp(s, sTRUE)==0);
	GetPrivateProfileString(sShell, "AlwaysOnTop", sFALSE, (LPSTR) s, 512, m_charIni);	m_always_on_top= (stricmp(s, sTRUE)==0);

	GetPrivateProfileString(sShell, "Symbol1", "", (LPSTR) s, 512, m_charIni);	m_symbol1= s;
	GetPrivateProfileString(sShell, "Symbol2", "", (LPSTR) s, 512, m_charIni);	m_symbol2= s;
	GetPrivateProfileString(sShell, "Symbol3", "", (LPSTR) s, 512, m_charIni);	m_symbol3= s;
	GetPrivateProfileString(sShell, "Symbol4", "", (LPSTR) s, 512, m_charIni);	m_symbol4= s;
	GetPrivateProfileString(sShell, "Symbol5", "", (LPSTR) s, 512, m_charIni);	m_symbol5= s;
	GetPrivateProfileString(sShell, "Symbol6", "", (LPSTR) s, 512, m_charIni);	m_symbol6= s;

	GetPrivateProfileString(sShell, "Format", "0", (LPSTR) s, 512, m_charIni);
	m_format= atoi(s);
	if (m_format<0)		m_format= 0;
	if (m_format>TOMAX)	m_format= TOMAX;
	format2pActFD();

	GetPrivateProfileString("UDO", "App", "", (LPSTR) s, 512, m_charIni);
	m_app_udo= s;
	GetPrivateProfileString("UDO", "Edi", "", (LPSTR) s, 512, m_charIni);
	m_edi_udo= s;

	read_format_data(&m_fd_ASC, "ASCII",		m_charIni);
	read_format_data(&m_fd_WIN, "WinHelp",		m_charIni);
	read_format_data(&m_fd_WH4, "WH4",			m_charIni);
	read_format_data(&m_fd_RTF, "RTF",			m_charIni);
	read_format_data(&m_fd_HTM, "HTML",			m_charIni);
	read_format_data(&m_fd_MHH, "HTML-Help",	m_charIni);
	read_format_data(&m_fd_TEX, "LaTeX",		m_charIni);
	read_format_data(&m_fd_PDF, "PDFLaTeX",		m_charIni);
	read_format_data(&m_fd_INF, "Texinfo",		m_charIni);
	read_format_data(&m_fd_MAN, "Manpage",		m_charIni);
	read_format_data(&m_fd_STG, "ST-Guide",		m_charIni);
	read_format_data(&m_fd_PCH, "Pure-C",		m_charIni);
	read_format_data(&m_fd_TVH, "Turbo-Vision",	m_charIni);
	read_format_data(&m_fd_LDS, "Linuxdoc",		m_charIni);
	read_format_data(&m_fd_AQV, "QuickView",	m_charIni);
	read_format_data(&m_fd_DRC, "DRC",			m_charIni);
	read_format_data(&m_fd_IPF, "IPF",			m_charIni);
	read_format_data(&m_fd_NRO, "nroff",		m_charIni);
	read_format_data(&m_fd_LYX, "LyX",			m_charIni);
	read_format_data(&m_fd_SRC, "C",			m_charIni);
	read_format_data(&m_fd_SRP, "Pascal",		m_charIni);
	read_format_data(&m_fd_UDO, "udo2udo",		m_charIni);
	read_format_data(&m_fd_KPS, "PS",			m_charIni);
	read_format_data(&m_fd_AMG, "AmigaGuide",	m_charIni);


	if (AfxGetApp()->m_lpCmdLine[0]!='\0')
	{	m_file_source= AfxGetApp()->m_lpCmdLine;

		if (m_file_source[0]=='\"')	// 0.95: " entfernen
		{	strcpy(s, m_file_source);
			sl= strlen(s);
			if (s[sl-1]=='\"')
			{	s[sl-1]= '\0';
				ptr= m_file_source.GetBuffer(512);
				strcpy(ptr, s+1);
				m_file_source.ReleaseBuffer();
			}
		}
	}

	return 0;
}


// Dateinamen anpassen

char *strmir ( char *s )
{
	size_t	sl, i;
	char	swap;
	
	if (  ( sl=strlen(s) ) > 0  )
	{	for (i=0; i<sl/2; i++)
		{	swap= s[i];
			s[i]= s[sl-i-1];
			s[sl-i-1]= swap;
		}
	}

	return(s);		
}	/* strmir */


void fsplit (CString cs, char *drive, char *path, char *filename, char *suffix)
{
	char	wrk[512], s[1024];
	char	*found;
	size_t	wl, fl, l;
	
	strcpy(s, cs);
	strcpy(drive, "");
	strcpy(path, "");
	strcpy(filename, "");
	strcpy(suffix, "");
	
	strcpy(wrk, s);
	wl= strlen(wrk);

	if ( wl==0 )	return;

	strcpy(wrk, s);
	strmir(wrk);
	
	/* Drive ermitteln und abschneiden */	
	if ( wrk[wl-2]==':' )
	{	strcpy(drive, "a:");
		drive[0]=wrk[wl-1];
		wrk[wl-2]='\0';
		wl= strlen(wrk);
	}

	/* Filenamen ermitteln und abschneiden */	
	strcpy(filename, wrk);
	l= 0;
	while ( (filename[l]!='\0') && (filename[l]!='\\') && (filename[l]!='/') ) l++;
	filename[l]='\0';
	strmir(filename);
	fl= strlen(filename);
	strmir(wrk);
	wrk[wl-fl]= '\0';	

	/* Jetzt noch aus dem Filenamen den Suffix extrahieren */
	if ( (found=strchr(filename, '.'))!=NULL )
	{	strcpy(suffix, found);
		filename[fl-strlen(suffix)]= '\0';
	}

	/* Das, was von <wrk> uebriggeblieben ist, ist der Pfad */
	strcpy(path, wrk);

}	/*fsplit*/


// berprfen, ob Datei vorhanden ist

BOOL file_available ( CString cs )
{
	FILE *file;

	file= fopen(cs, "rb");

	if (!file)
	{	return FALSE;
	}

	fclose(file);

	return TRUE;
}


// Selbsterklrend
void backslash2slash ( char *s )
{
	size_t i;

	for (i=0; i<strlen(s); i++)
	{
		if (s[i]=='\\')
		{	s[i]= '/';
		}
	}
}

int change_dir ( CString cs )
{
	char driv[32], path[512], name[512], suff[512];
	size_t sl;

	fsplit(cs, driv, path, name, suff);

	sprintf(name, "%s%s", driv, path);

	sl= strlen(name);
	if (sl>0)
	{	if (name[sl-1]=='\\' || name[sl-1]=='/')
		{	name[sl-1]= '\0';
		}
		return chdir(name);
	}

	return 0;
}

int make_dir ( CString cs )
{
	char driv[32], path[512], name[512], suff[512];
	size_t sl;

	fsplit(cs, driv, path, name, suff);

	sprintf(name, "%s%s", driv, path);

	sl= strlen(name);
	if (sl>0)
	{	if (name[sl-1]=='\\' || name[sl-1]=='/')
		{	name[sl-1]= '\0';
		}
		return mkdir(name);
	}

	return 1;
}


void CUdosh32Dlg::SetIniFilename() 
{
	char *ptr, *first, driv[32], path[260], name[260], suff[260], s[512];
	size_t len= 0;
	BOOL quoted= FALSE;

	if (m_charIni[0]!='\0')
	{	return;
	}

	// Hier argv0 ermitteln: GetCommandLine liefert einen Zeiger auf so etwas:
	// "C:\daten\msvc\udosh32\debug\udosh32.exe" <kommandos>
	// argv[0] steht also in Anfhrungsstrichen
#if 1
	ptr= GetCommandLine();

	if (ptr!=NULL && *ptr!='\0')
	{
		if (*ptr=='\"')
		{	ptr++;
			quoted= TRUE;
		}
		first=ptr;
		if (quoted)
		{	while (*ptr!='\"' && *ptr!='\0')
			{	len++;
				ptr++;
			}
		}
		else
		{	while (*ptr!=' ' && *ptr!='\0')
			{	len++;
				ptr++;
			}
		}

		if (len>0)
		{	s[0]= '\0';
			strncpy(s, first, len);
			s[len]= '\0';
		}
		fsplit(s, driv, path, name, suff);
		sprintf(m_charIni, "%s%s%s.ini", driv, path, name);
	}
	else
	{	strcpy (m_charIni, "udosh32.ini");
	}
#else
	strcpy(m_charIni, "udosh32.ini");
#endif

#ifdef _DEBUG
# if 0
	MessageBox(m_charIni, "UDOSH32 (Debug):", MB_OK | MB_ICONINFORMATION);
# endif
#endif
}


BOOL CUdosh32Dlg::choose_file(char *name, size_t maxSize, char *title, const char *filter, const char *defext) 
{
	DWORD dw;
	OPENFILENAME ofn;
	CString cName;
	int sl;
	char fdriv[32], fpath[512], fname[512], fsuff[256];

    ofn.lStructSize= sizeof(OPENFILENAME); 
    ofn.hwndOwner= AfxGetMainWnd()->GetSafeHwnd(); 
    ofn.hInstance= AfxGetInstanceHandle(); 
    ofn.lpstrFilter= (LPSTR) filter; 
    ofn.lpstrCustomFilter= NULL; 
    ofn.nMaxCustFilter= 0; 
    ofn.nFilterIndex= 1; 
    ofn.lpstrFile= (LPSTR) name; 
    ofn.nMaxFile= maxSize; 
    ofn.lpstrFileTitle= NULL; 
    ofn.nMaxFileTitle= 0; 
    ofn.lpstrInitialDir= NULL; 
    ofn.lpstrTitle= title; 
    ofn.Flags= OFN_FILEMUSTEXIST | OFN_LONGNAMES | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY; 
    ofn.nFileOffset= 0; 
    ofn.nFileExtension= 0; 
    ofn.lpstrDefExt= defext; 
    ofn.lCustData= NULL; 
    ofn.lpfnHook= NULL; 
    ofn.lpTemplateName= NULL; 

	sl= strlen(name);
	if (sl>0)
	{	strcpy(cName.GetBuffer(sl+1), name);
		cName.ReleaseBuffer();
		fsplit(cName, fdriv, fpath, fname, fsuff);
		sprintf(fname, "%s%s", fdriv, fpath);
	    ofn.lpstrInitialDir= (LPSTR) fname; 
	}

	name[0]= '\0';

	if ( GetOpenFileName(&ofn) )
	{	strcpy(name, ofn.lpstrFile);
		return TRUE;
	}

	dw= CommDlgExtendedError();
	if (dw!=0)
	{	MessageBox("CommDlgExtendedError()", NULL, MB_OK | MB_ICONSTOP);
	}

	return FALSE;

}

void CUdosh32Dlg::OnChooseSource()
{
	char chosen[1024];
	size_t sl;
	char *filter= "UDO files (*.u*)\0*.u*\0All files (*.*)\0*.*\0\0";

	strcpy(chosen, m_file_source);

	if (choose_file(chosen, sizeof(chosen), "Choose UDO source file...", filter, "u*"))
	{
		sl= strlen(chosen);
		strcpy(m_file_source.GetBuffer(sl+1), chosen);
		m_file_source.ReleaseBuffer();
		UpdateData(FALSE);
		adjust_files();
		adjust_buttons();
	}
}


void CUdosh32Dlg::OnChooseDest() 
{
	char chosen[1024];
	size_t sl;
	char *filter= "All files (*.*)\0*.*\0\0";

	strcpy(chosen, m_file_source);

	if (choose_file(chosen, sizeof(chosen), "Choose destination file...", filter, "*"))
	{
		sl= strlen(chosen);
		strcpy(m_file_dest.GetBuffer(sl+1), chosen);
		m_file_dest.ReleaseBuffer();
		UpdateData(FALSE);
		adjust_other_files();
		adjust_buttons();
	}
}


void CUdosh32Dlg::WinExecErrorMB (UINT ui)
{
	char mb[512];

	if (ui<=31)
	{	sprintf(mb, "WinExec() returned error #%u!", ui);

		switch(ui)
		{
			case 0:
				strcat(mb, "\n");
				strcat(mb, "The system is out of memory or resources.");
				break;
			case ERROR_BAD_FORMAT:
				strcat(mb, "\n");
				strcat(mb, "The .EXE file is invalid (non-Win32 .EXE or error in .EXE image).");
				break;
			case ERROR_FILE_NOT_FOUND:
				strcat(mb, "\n");
				strcat(mb, "The specified .EXE file was not found.");
				break;
			case ERROR_PATH_NOT_FOUND:
				strcat(mb, "\n");
				strcat(mb, "The specified .EXE path was not found.");
				break;
		}

		MessageBox(mb, NULL, MB_OK | MB_ICONEXCLAMATION);
	}
}



void CUdosh32Dlg::OnEditSource() 
{
	char cmd[1024];
	int ret;
	SHORT ks;

	UpdateData(TRUE);

	ks= GetKeyState(VK_CONTROL);

	if (ks & 128 || ((m_file_source.GetLength()>0) && (m_edi_udo.GetLength()==0)) )
	{
		// Control gedrckt: 128 = High Order Bit
		size_t sl;
		char *filter= "Program files (*.exe;*.bat)\0*.exe;*.bat\0All files (*.*)\0*.*\0\0";

		strcpy(cmd, m_edi_udo);

		if (choose_file(cmd, sizeof(cmd), "Choose editor for UDO and log files...", filter, "exe"))
		{
			sl= strlen(cmd);
			strcpy(m_edi_udo.GetBuffer(sl+1), cmd);
			m_edi_udo.ReleaseBuffer();
			UpdateData(FALSE);
			adjust_buttons();
		}
		return;
	}


	if (m_file_source.GetLength()==0)
	{	MessageBox("Please select a source file first!", NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	if (!file_available(m_file_source))
	{	ret= MessageBox("The source file doesn't exist.\nStart the editor anyway?", NULL, MB_YESNO | MB_ICONQUESTION);
		if (ret!=IDYES)
		{	return;
		}
	}
	
	change_dir(m_file_source);

	if (strstr(m_file_source, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_edi_udo, m_file_source);
	}
	else
	{	sprintf(cmd, "%s %s", m_edi_udo, m_file_source);
	}

	WinExec(cmd, SW_SHOWNORMAL);
}

void CUdosh32Dlg::OnEditDest() 
{
	char cmd[1024];
	int ret;
	SHORT ks;

	UpdateData(TRUE);

	ks= GetKeyState(VK_CONTROL);

	if (ks & 128 || ((m_file_dest.GetLength()>0) && (m_pActFD->DestEdi.GetLength()==0)) )
	{
		// Control gedrckt: 128 = High Order Bit
		size_t sl;
		char *filter= "Program files (*.exe;*.bat)\0*.exe;*.bat\0All files (*.*)\0*.*\0\0";

#if 0
		if (m_edi_udo.GetLength()>0)
		{
			sprintf(cmd, "Do you want to use the standard editor?\n%s", m_edi_udo);
			ret= MessageBox(cmd, NULL, MB_YESNO | MB_ICONQUESTION);
			if (ret==IDYES)
			{	m_pActFD->DestEdi= m_edi_udo;
				UpdateData(FALSE);
				adjust_buttons();
				return;
			}
		}
#endif

		strcpy(cmd, m_pActFD->DestEdi);

		if (choose_file(cmd, sizeof(cmd), "Choose editor for destination file...", filter, "exe"))
		{
			sl= strlen(cmd);
			strcpy(m_pActFD->DestEdi.GetBuffer(sl+1), cmd);
			m_pActFD->DestEdi.ReleaseBuffer();
			UpdateData(FALSE);
			adjust_buttons();
		}
		return;
	}


	if (m_file_dest.GetLength()==0)
	{	MessageBox("No destination file available!", NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}
		
	if (!file_available(m_file_dest))
	{	ret= MessageBox("The destination file doesn't exist.\nStart the editor anyway?", NULL, MB_YESNO | MB_ICONQUESTION);
		if (ret!=IDYES)
		{	return;
		}
	}

	change_dir(m_file_dest);

	if (strstr(m_file_dest, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_pActFD->DestEdi, m_file_dest);
	}
	else
	{	sprintf(cmd, "%s %s", m_pActFD->DestEdi, m_file_dest);
	}

	WinExec(cmd, SW_SHOWNORMAL);
}

void CUdosh32Dlg::OnEditParam() 
{
	char cmd[1024];
	int ret;
	SHORT ks;

	UpdateData(TRUE);

	ks= GetKeyState(VK_CONTROL);

	if (ks & 128 || ((m_file_param.GetLength()>0) && (m_pActFD->ParamEdi.GetLength()==0)) )
	{
		// Control gedrckt: 128 = High Order Bit
		size_t sl;
		char *filter= "Program files (*.exe;*.bat)\0*.exe;*.bat\0All files (*.*)\0*.*\0\0";

		strcpy(cmd, m_pActFD->ParamEdi);

		if (choose_file(cmd, sizeof(cmd), "Choose editor for parameter file...", filter, "exe"))
		{
			sl= strlen(cmd);
			strcpy(m_pActFD->ParamEdi.GetBuffer(sl+1), cmd);
			m_pActFD->ParamEdi.ReleaseBuffer();
			UpdateData(FALSE);
			adjust_buttons();
		}
		return;
	}

	if (m_file_param.GetLength()==0)
	{	return;
	}

	if (!file_available(m_file_param))
	{	ret= MessageBox("The parameter file doesn't exist.\nStart the editor anyway?", NULL, MB_YESNO | MB_ICONQUESTION);
		if (ret!=IDYES)
		{	return;
		}
	}

	change_dir(m_file_param);

	if (strstr(m_file_param, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_pActFD->ParamEdi, m_file_param);
	}
	else
	{	sprintf(cmd, "%s %s", m_pActFD->ParamEdi, m_file_param);
	}

	WinExec(cmd, SW_SHOWNORMAL);
}


void CUdosh32Dlg::OnEditParam2() 
{
	char cmd[1024];
	int ret;
	SHORT ks;

	UpdateData(TRUE);

	ks= GetKeyState(VK_CONTROL);

	if (ks & 128 || ((m_file_param2.GetLength()>0) && (m_pActFD->Param2Edi.GetLength()==0)) )
	{
		// Control gedrckt: 128 = High Order Bit
		size_t sl;
		char *filter= "Program files (*.exe;*.bat)\0*.exe;*.bat\0All files(*.*)\0*.*\0\0";

		strcpy(cmd, m_pActFD->Param2Edi);

		if (choose_file(cmd, sizeof(cmd), "Choose editor for parameter file...", filter, "exe"))
		{
			sl= strlen(cmd);
			strcpy(m_pActFD->Param2Edi.GetBuffer(sl+1), cmd);
			m_pActFD->Param2Edi.ReleaseBuffer();
			UpdateData(FALSE);
			adjust_buttons();
		}
		return;
	}

	if (m_file_param2.GetLength()==0)
	{	return;
	}

	if (!file_available(m_file_param2))
	{	ret= MessageBox("The parameter file doesn't exist.\nStart the editor anyway??", NULL, MB_YESNO | MB_ICONQUESTION);
		if (ret!=IDYES)
		{	return;
		}
	}

	change_dir(m_file_param2);

	if (strstr(m_file_param2, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_pActFD->Param2Edi, m_file_param2);
	}
	else
	{	sprintf(cmd, "%s %s", m_pActFD->Param2Edi, m_file_param2);
	}

	WinExec(cmd, SW_SHOWNORMAL);
}

void CUdosh32Dlg::OnEditFinal() 
{
	char cmd[1024];
	int ret;
	SHORT ks;

	UpdateData(TRUE);

	ks= GetKeyState(VK_CONTROL);

	if (ks & 128 || ((m_file_final.GetLength()>0) && (m_pActFD->FinalEdi.GetLength()==0)) )
	{
		// Control gedrckt: 128 = High Order Bit
		size_t sl;
		char *filter= "Program files (*.exe;*.bat)\0*.exe;*.bat\0All files(*.*)\0*.*\0\0";

		strcpy(cmd, m_pActFD->FinalEdi);

		if (choose_file(cmd, sizeof(cmd), "Choose editor for result file...", filter, "exe"))
		{
			sl= strlen(cmd);
			strcpy(m_pActFD->FinalEdi.GetBuffer(sl+1), cmd);
			m_pActFD->FinalEdi.ReleaseBuffer();
			UpdateData(FALSE);
			adjust_buttons();
		}
		return;
	}

	if (m_file_final.GetLength()==0)
	{	return;
	}

	if (!file_available(m_file_final))
	{	ret= MessageBox("The result file doesn't exist.\nStart the editor anyway??", NULL, MB_YESNO | MB_ICONQUESTION);
		if (ret!=IDYES)
		{	return;
		}
	}
	
	change_dir(m_file_final);

	if (strstr(m_file_final, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_pActFD->FinalEdi, m_file_final);
	}
	else
	{	sprintf(cmd, "%s %s", m_pActFD->FinalEdi, m_file_final);
	}

	WinExec(cmd, SW_SHOWNORMAL);
}

void CUdosh32Dlg::OnExecSource() 
{
	char cmd[1024];
	UINT ret;
	SHORT ks;

	UpdateData(TRUE);

	ks= GetKeyState(VK_CONTROL);

	if (ks & 128 || ((m_file_source.GetLength()>0) && (m_app_udo.GetLength()==0)) )
	{
		// Control gedrckt: 128 = High Order Bit
		size_t sl;
		char *filter= "Program files (*.exe;*.bat)\0*.exe;*.bat\0All files(*.*)\0*.*\0\0";

		strcpy(cmd, m_app_udo);

		if (choose_file(cmd, sizeof(cmd), "Choose UDO binary...", filter, "exe"))
		{
			sl= strlen(cmd);
			strcpy(m_app_udo.GetBuffer(sl+1), cmd);
			m_app_udo.ReleaseBuffer();
			UpdateData(FALSE);
			adjust_buttons();
		}
		return;
	}

	if (m_file_source.GetLength()==0)
	{	MessageBox("No source file available!", NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	if (m_file_dest.GetLength()==0)
	{	MessageBox("No destiantion file available!", NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	if (!file_available(m_file_source))
	{	MessageBox("No source file doesn't exist!", NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	strcpy(cmd, m_app_udo);
	strcat(cmd, " ");

	switch (m_format)
	{
		case TOASC:	strcat(cmd, "-a ");		break;
		case TOWIN:	strcat(cmd, "-w ");		break;
		case TOWH4:	strcat(cmd, "-4 ");		break;
		case TORTF:	strcat(cmd, "-r ");		break;
		case TOHTM:	strcat(cmd, "-h ");		break;
		case TOMHH:	strcat(cmd, "-hh ");	break;
		case TOTEX:	strcat(cmd, "-t ");		break;
		case TOPDF:	strcat(cmd, "-f ");		break;
		case TOINF:	strcat(cmd, "-i ");		break;
		case TOMAN:	strcat(cmd, "-m ");		break;
		case TOSTG:	strcat(cmd, "-s ");		break;
		case TOAMG:	strcat(cmd, "--amg ");	break;
		case TOPCH:	strcat(cmd, "-p ");		break;
		case TOTVH:	strcat(cmd, "-v ");		break;
		case TOLDS:	strcat(cmd, "-x ");		break;
		case TOAQV:	strcat(cmd, "--aqv ");	break;
		case TODRC:	strcat(cmd, "--drc ");	break;
		case TOIPF:	strcat(cmd, "--ipf ");	break;
		case TOLYX:	strcat(cmd, "--lyx ");	break;
		case TONRO:	strcat(cmd, "-1 ");		break;
		case TOSRC:	strcat(cmd, "--c ");	break;
		case TOSRP:	strcat(cmd, "-P ");		break;
		case TOUDO:	strcat(cmd, "-u ");		break;
		case TOKPS:	strcat(cmd, "--ps ");	break;
	}

	if (!m_use_log)		strcat(cmd, "-l ");
	if (m_use_check)	strcat(cmd, "--check ");
	if (!m_use_hyp)		strcat(cmd, "-y ");
	if (m_use_tree)		strcat(cmd, "--tree ");
	if (m_use_upr)		strcat(cmd, "--save-upr ");
	if (m_use_verb)		strcat(cmd, "--verbose ");
	if (m_hold_key)		strcat(cmd, "--hold ");
	if (!m_warnings)	strcat(cmd, "-W ");


	if (m_use_sym1 && m_symbol1.GetLength()>0)
	{	strcat(cmd, "-D ");
		strcat(cmd, m_symbol1);
		strcat(cmd, " ");
	}

	if (m_use_sym2 && m_symbol2.GetLength()>0)
	{	strcat(cmd, "-D ");
		strcat(cmd, m_symbol2);
		strcat(cmd, " ");
	}

	if (m_use_sym3 && m_symbol3.GetLength()>0)
	{	strcat(cmd, "-D ");
		strcat(cmd, m_symbol3);
		strcat(cmd, " ");
	}

	if (m_use_sym4 && m_symbol4.GetLength()>0)
	{	strcat(cmd, "-D ");
		strcat(cmd, m_symbol4);
		strcat(cmd, " ");
	}

	if (m_use_sym5 && m_symbol5.GetLength()>0)
	{	strcat(cmd, "-D ");
		strcat(cmd, m_symbol5);
		strcat(cmd, " ");
	}

	if (m_use_sym6 && m_symbol6.GetLength()>0)
	{	strcat(cmd, "-D ");
		strcat(cmd, m_symbol6);
		strcat(cmd, " ");
	}


	if (m_format==TOWIN || m_format==TOWH4)
	{
		if (m_use_map_pas)	strcat(cmd, "--map-pas ");
		if (m_use_map_gfa)	strcat(cmd, "--map-gfa ");
		if (m_use_map_vb)	strcat(cmd, "--map-vb ");
	}

#if 0
	MessageBox(cmd, NULL, MB_OK | MB_ICONINFORMATION);
#endif

	if (change_dir(m_file_dest)!=0)
	{	ret= MessageBox(
			"The destination directory doesn't exist.\n"
			"Make directory now to prevent UDO from\n"
			"displaying an error message?",
			NULL,
			MB_OKCANCEL | MB_ICONQUESTION);
		
		if (ret==IDOK)
		{	//Verzeichnis anlegen
			if (make_dir(m_file_dest)!=0)
			{	MessageBox("Couldn't make directory!", NULL, MB_OK | MB_ICONSTOP);
				return;
			}
		}
		else
		{	return;
		}
	}

	if (change_dir(m_file_dest)!=0)
	{	MessageBox("Directory doesn't exist!?", NULL, MB_OK | MB_ICONSTOP);
		return;
	}

	// Kommandozeile noch mit Ziel-/Quelldatei vervollstndigen
	strcat(cmd, "-o ");

	if (strstr(m_file_dest, " ")!=NULL)	// 0.95: Leerzeichen? Dann mit " klammern
	{	strcat(cmd, "\"");
		strcat(cmd, m_file_dest);
		strcat(cmd, "\"");
	}
	else
	{	strcat(cmd, m_file_dest);
	}

	strcat(cmd, " ");

	if (strstr(m_file_source, " ")!=NULL)	// 0.95: Leerzeichen? Dann mit " klammern
	{	strcat(cmd, "\"");
		strcat(cmd, m_file_source);
		strcat(cmd, "\"");
	}
	else
	{	strcat(cmd, m_file_source);
	}


	ret= WinExec(cmd, SW_SHOWNORMAL);
	WinExecErrorMB(ret);
}


void CUdosh32Dlg::OnExecDest() 
{
	char cmd[1024], f[1024];
	SHORT ks;

	UpdateData(TRUE);

	ks= GetKeyState(VK_CONTROL);

	if (ks & 128 || ((m_file_dest.GetLength()>0) && (m_pActFD->DestApp.GetLength()==0)) )
	{
		// Control gedrckt: 128 = High Order Bit
		size_t sl;
		char *filter= "Program files (*.exe;*.bat)\0*.exe;*.bat\0All files(*.*)\0*.*\0\0";

		strcpy(cmd, m_pActFD->DestApp);

		if (choose_file(cmd, sizeof(cmd), "Choose application for destination file...", filter, "exe"))
		{
			sl= strlen(cmd);
			strcpy(m_pActFD->DestApp.GetBuffer(sl+1), cmd);
			m_pActFD->DestApp.ReleaseBuffer();
			UpdateData(FALSE);
			adjust_buttons();
		}
		return;
	}

	if (m_file_dest.GetLength()==0)
	{	return;
	}


	if (!file_available(m_file_dest))
	{	MessageBox("The result file doesn't exist.", NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	change_dir(m_file_dest);
	strcpy(f, m_file_dest);
	if (m_pActFD->DestUnix)
	{	backslash2slash(f);
	}

	if (strstr(f, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_pActFD->DestApp, f);
	}
	else
	{	sprintf(cmd, "%s %s", m_pActFD->DestApp, f);
	}

	WinExec(cmd, SW_SHOWNORMAL);
}


void CUdosh32Dlg::OnExecParam() 
{
	char cmd[1024];
	SHORT ks;

	UpdateData(TRUE);

	ks= GetKeyState(VK_CONTROL);

	if (ks & 128 || ((m_file_param.GetLength()>0) && (m_pActFD->ParamApp.GetLength()==0)) )
	{
		// Control gedrckt: 128 = High Order Bit
		size_t sl;
		char *filter= "Program files (*.exe;*.bat)\0*.exe;*.bat\0All files(*.*)\0*.*\0\0";

		strcpy(cmd, m_pActFD->ParamApp);

		if (choose_file(cmd, sizeof(cmd), "Choose application for parameter file...", filter, "exe"))
		{
			sl= strlen(cmd);
			strcpy(m_pActFD->ParamApp.GetBuffer(sl+1), cmd);
			m_pActFD->ParamApp.ReleaseBuffer();
			UpdateData(FALSE);
			adjust_buttons();
		}
		return;
	}

	if (m_file_param.GetLength()==0)
	{	return;
	}


	if (!file_available(m_file_param))
	{	MessageBox("The parameter file doesn't exist.", NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	change_dir(m_file_param);

	if (strstr(m_file_param, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_pActFD->ParamApp, m_file_param);
	}
	else
	{	sprintf(cmd, "%s %s", m_pActFD->ParamApp, m_file_param);
	}

	WinExec(cmd, SW_SHOWNORMAL);
}

void CUdosh32Dlg::OnExecParam2() 
{
	char cmd[1024];
	SHORT ks;

	UpdateData(TRUE);

	ks= GetKeyState(VK_CONTROL);

	if (ks & 128 || ((m_file_param2.GetLength()>0) && (m_pActFD->Param2App.GetLength()==0)) )
	{
		// Control gedrckt: 128 = High Order Bit
		size_t sl;
		char *filter= "Program files (*.exe;*.bat)\0*.exe;*.bat\0All files(*.*)\0*.*\0\0";

		strcpy(cmd, m_pActFD->Param2App);

		if (choose_file(cmd, sizeof(cmd), "Choose application for parameter file...", filter, "exe"))
		{
			sl= strlen(cmd);
			strcpy(m_pActFD->Param2App.GetBuffer(sl+1), cmd);
			m_pActFD->Param2App.ReleaseBuffer();
			UpdateData(FALSE);
			adjust_buttons();
		}
		return;
	}

	if (m_file_param2.GetLength()==0)
	{	return;
	}


	if (!file_available(m_file_param2))
	{	MessageBox("The parameter file doesn't exist.", NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	change_dir(m_file_param2);

	if (strstr(m_file_param2, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_pActFD->Param2App, m_file_param2);
	}
	else
	{	sprintf(cmd, "%s %s", m_pActFD->Param2App, m_file_param2);
	}

	WinExec(cmd, SW_SHOWNORMAL);
}

void CUdosh32Dlg::OnExecFinal() 
{
	char cmd[1024];
	SHORT ks;

	UpdateData(TRUE);

	ks= GetKeyState(VK_CONTROL);

	if (ks & 128 || ((m_file_final.GetLength()>0) && (m_pActFD->FinalApp.GetLength()==0)) )
	{
		// Control gedrckt: 128 = High Order Bit
		size_t sl;
		char *filter= "Program files (*.exe;*.bat)\0*.exe;*.bat\0All files(*.*)\0*.*\0\0";

		strcpy(cmd, m_pActFD->FinalApp);

		if (choose_file(cmd, sizeof(cmd), "Choose application for result file...", filter, "exe"))
		{
			sl= strlen(cmd);
			strcpy(m_pActFD->FinalApp.GetBuffer(sl+1), cmd);
			m_pActFD->FinalApp.ReleaseBuffer();
			UpdateData(FALSE);
			adjust_buttons();
		}
		return;
	}

	if (m_file_final.GetLength()==0)
	{	return;
	}


	if (!file_available(m_file_final))
	{	MessageBox("The result file doesn't exist.", NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	change_dir(m_file_final);
	if (strstr(m_file_final, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_pActFD->FinalApp, m_file_final);
	}
	else
	{	sprintf(cmd, "%s %s", m_pActFD->FinalApp, m_file_final);
	}
	WinExec(cmd, SW_SHOWNORMAL);
}


void CUdosh32Dlg::MbNoUdoEdi() 
{
		MessageBox(
			"You haven't defined an editor for UDO files!\n"
			"Click the upper right button while pressing\n"
			"the ctrl key to choose an editor.",
			NULL,
			MB_OK | MB_ICONEXCLAMATION);
}

void CUdosh32Dlg::OnButtonLog() 
{
	char cmd[1024];

	UpdateData(TRUE);

	if (m_file_log.GetLength()==0)
	{	return;
	}

	if (m_edi_udo.GetLength()==0)
	{	MbNoUdoEdi();
	}

	if (!file_available(m_file_log))
	{	sprintf(cmd, "The log file\n%s\ndoesn't exist.", m_file_log);
		MessageBox(cmd, NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	change_dir(m_file_log);
	if (strstr(m_file_log, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_edi_udo, m_file_log);
	}
	else
	{	sprintf(cmd, "%s %s", m_edi_udo, m_file_log);
	}
	WinExec(cmd, SW_SHOWNORMAL);
}

void CUdosh32Dlg::OnButtonHyp() 
{
	char cmd[1024];

	UpdateData(TRUE);

	if (m_file_hyp.GetLength()==0)
	{	return;
	}

	if (m_edi_udo.GetLength()==0)
	{	MbNoUdoEdi();
	}

	if (!file_available(m_file_hyp))
	{	sprintf(cmd, "The hyphenation pattern file\n%s\ndoesn't exist.", m_file_hyp);
		MessageBox(cmd, NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}
	
	change_dir(m_file_hyp);
	if (strstr(m_file_hyp, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_edi_udo, m_file_hyp);
	}
	else
	{	sprintf(cmd, "%s %s", m_edi_udo, m_file_hyp);
	}
	WinExec(cmd, SW_SHOWNORMAL);
}

void CUdosh32Dlg::OnButtonTree() 
{
	char cmd[1024];

	UpdateData(TRUE);

	if (m_file_tree.GetLength()==0)
	{	return;
	}

	if (m_edi_udo.GetLength()==0)
	{	MbNoUdoEdi();
	}

	if (!file_available(m_file_tree))
	{	sprintf(cmd, "The tree file\n%s\ndoesn't exist.", m_file_tree);
		MessageBox(cmd, NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	change_dir(m_file_tree);
	if (strstr(m_file_tree, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_edi_udo, m_file_tree);
	}
	else
	{	sprintf(cmd, "%s %s", m_edi_udo, m_file_tree);
	}
	WinExec(cmd, SW_SHOWNORMAL);
}


void CUdosh32Dlg::OnButtonMapPas() 
{
	char cmd[1024];

	UpdateData(TRUE);

	if (m_file_map_pas.GetLength()==0)
	{	return;
	}

	if (m_edi_udo.GetLength()==0)
	{	MbNoUdoEdi();
	}

	if (!file_available(m_file_map_pas))
	{	sprintf(cmd, "The map file\n%s\ndoesn't exist.", m_file_map_pas);
		MessageBox(cmd, NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	change_dir(m_file_map_pas);
	if (strstr(m_file_map_pas, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_edi_udo, m_file_map_pas);
	}
	else
	{	sprintf(cmd, "%s %s", m_edi_udo, m_file_map_pas);
	}
	WinExec(cmd, SW_SHOWNORMAL);
}

void CUdosh32Dlg::OnButtonMapGfa() 
{
	char cmd[1024];

	UpdateData(TRUE);

	if (m_file_map_gfa.GetLength()==0)
	{	return;
	}

	if (m_edi_udo.GetLength()==0)
	{	MbNoUdoEdi();
	}

	if (!file_available(m_file_map_gfa))
	{	sprintf(cmd, "The map file\n%s\ndoesn't exist.", m_file_map_gfa);
		MessageBox(cmd, NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	change_dir(m_file_map_gfa);
	if (strstr(m_file_map_gfa, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_edi_udo, m_file_map_gfa);
	}
	else
	{	sprintf(cmd, "%s %s", m_edi_udo, m_file_map_gfa);
	}
	WinExec(cmd, SW_SHOWNORMAL);
}

void CUdosh32Dlg::OnButtonMapVb() 
{
	char cmd[1024];

	UpdateData(TRUE);

	if (m_file_map_vb.GetLength()==0)
	{	return;
	}

	if (m_edi_udo.GetLength()==0)
	{	MbNoUdoEdi();
	}

	if (!file_available(m_file_map_vb))
	{	sprintf(cmd, "The map file\n%s\ndoesn't exist.", m_file_map_vb);
		MessageBox(cmd, NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	change_dir(m_file_map_vb);
	if (strstr(m_file_map_vb, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_edi_udo, m_file_map_vb);
	}
	else
	{	sprintf(cmd, "%s %s", m_edi_udo, m_file_map_vb);
	}
	WinExec(cmd, SW_SHOWNORMAL);
}

void CUdosh32Dlg::OnButtonUpr() 
{
	char cmd[1024];

	UpdateData(TRUE);

	if (m_file_tree.GetLength()==0)
	{	return;
	}

	if (m_edi_udo.GetLength()==0)
	{	MbNoUdoEdi();
	}

	if (!file_available(m_file_upr))
	{	sprintf(cmd, "The project file\n%s\ndoesn't exist.", m_file_upr);
		MessageBox(cmd, NULL, MB_OK | MB_ICONEXCLAMATION);
		return;
	}

	change_dir(m_file_upr);
	if (strstr(m_file_upr, " ")!=NULL)	// 0.95
	{	sprintf(cmd, "%s \"%s\"", m_edi_udo, m_file_upr);
	}
	else
	{	sprintf(cmd, "%s %s", m_edi_udo, m_file_upr);
	}
	WinExec(cmd, SW_SHOWNORMAL);
	
}

// In m_pActFD wird der Zeiger auf das aktuelle Format
// gemerkt. Er mu jedesmal angepat werden, sobald
// sich das Format in der Shell ndert.

void CUdosh32Dlg::format2pActFD()
{
	switch (m_format)
	{
		case TOASC:	m_pActFD= &m_fd_ASC;	break;
		case TOWIN:	m_pActFD= &m_fd_WIN;	break;
		case TOWH4:	m_pActFD= &m_fd_WH4;	break;
		case TORTF:	m_pActFD= &m_fd_RTF;	break;
		case TOHTM:	m_pActFD= &m_fd_HTM;	break;
		case TOMHH:	m_pActFD= &m_fd_MHH;	break;
		case TOTEX:	m_pActFD= &m_fd_TEX;	break;

		case TOPDF:	m_pActFD= &m_fd_PDF;	break;
		case TOINF:	m_pActFD= &m_fd_INF;	break;
		case TOMAN:	m_pActFD= &m_fd_MAN;	break;
		case TOSTG:	m_pActFD= &m_fd_STG;	break;
		case TOPCH:	m_pActFD= &m_fd_PCH;	break;
		case TOTVH:	m_pActFD= &m_fd_TVH;	break;
		
		case TOLDS:	m_pActFD= &m_fd_LDS;	break;
		case TOAQV:	m_pActFD= &m_fd_AQV;	break;
		case TODRC:	m_pActFD= &m_fd_DRC;	break;
		case TOIPF:	m_pActFD= &m_fd_IPF;	break;
		case TOLYX:	m_pActFD= &m_fd_LYX;	break;
		case TONRO:	m_pActFD= &m_fd_NRO;	break;
		
		case TOSRC:	m_pActFD= &m_fd_SRC;	break;
		case TOSRP:	m_pActFD= &m_fd_SRP;	break;
		case TOUDO:	m_pActFD= &m_fd_UDO;	break;
		case TOKPS:	m_pActFD= &m_fd_KPS;	break;
		case TOAMG:	m_pActFD= &m_fd_AMG;	break;

		default:	m_pActFD= &m_fd_ASC;	break;
	}
}


void CUdosh32Dlg::get_log_suffix(char *slog, int format)
{
	switch (format)
	{
		case TOASC:	strcpy(slog, ".ula");	break;
		case TOWIN:	strcpy(slog, ".ulw");	break;
		case TOWH4:	strcpy(slog, ".ul4");	break;
		case TORTF:	strcpy(slog, ".ulr");	break;
		case TOHTM:	strcpy(slog, ".ulh");	break;
		case TOMHH:	strcpy(slog, ".ulh");	break;
		case TOTEX:	strcpy(slog, ".ult");	break;

		case TOPDF:	strcpy(slog, ".ulf");	break;
		case TOINF:	strcpy(slog, ".uli");	break;
		case TOMAN:	strcpy(slog, ".ulm");	break;
		case TOSTG:	strcpy(slog, ".uls");	break;
		case TOPCH:	strcpy(slog, ".ulp");	break;
		case TOTVH:	strcpy(slog, ".ult");	break;

		case TOLDS:	strcpy(slog, ".uls");	break;
		case TOAQV:	strcpy(slog, ".ulq");	break;
		case TODRC:	strcpy(slog, ".uld");	break;
		case TOIPF:	strcpy(slog, ".uli");	break;
		case TOLYX:	strcpy(slog, ".ull");	break;
		case TONRO:	strcpy(slog, ".uln");	break;

		case TOSRC:	strcpy(slog, ".ulc");	break;
		case TOSRP:	strcpy(slog, ".ulp");	break;
		case TOUDO:	strcpy(slog, ".ulu");	break;
		case TOKPS:	strcpy(slog, ".ulp");	break;
		case TOAMG:	strcpy(slog, ".ulg");	break;

		default:	strcpy(slog, ".ula");	break;
	}
}


void CUdosh32Dlg::adjust_files()
{
	char driv[32], path[512], name[512], suff[512], namlow[512];
	char s[512], slog[8], shyp[8], stre[8], smap[8], addpath[16];
	size_t sl;

	UpdateData(TRUE);
	format2pActFD();

	m_file_dest= "";
	m_file_param= "";
	m_file_param2= "";
	m_file_final= "";
	m_file_log= "";
	m_file_hyp= "";
	m_file_tree= "";
	m_file_map_pas= "";
	m_file_map_gfa= "";
	m_file_map_vb= "";
	m_file_upr= "";

	if (m_file_source.GetLength()==0)
	{	UpdateData(FALSE);
		return;
	}

	fsplit(m_file_source, driv, path, name, suff);

	switch (m_format)
	{
		case TOASC:	strcpy(suff, ".txt");	strcpy(slog, ".ula");	strcpy(addpath, "ascii");		break;
		case TOWIN:	strcpy(suff, ".rtf");	strcpy(slog, ".ulw");	strcpy(addpath, "winhelp");		break;
		case TOWH4:	strcpy(suff, ".rtf");	strcpy(slog, ".ul4");	strcpy(addpath, "winhelp4");	break;
		case TORTF:	strcpy(suff, ".rtf");	strcpy(slog, ".ulr");	strcpy(addpath, "rtf");			break;
		case TOHTM:	strcpy(suff, ".html");	strcpy(slog, ".ulh");	strcpy(addpath, "html");		break;
		case TOMHH:	strcpy(suff, ".html");	strcpy(slog, ".ulh");	strcpy(addpath, "htmlhelp");	break;
		case TOTEX:	strcpy(suff, ".tex");	strcpy(slog, ".ult");	strcpy(addpath, "latex");		break;
		case TOPDF:	strcpy(suff, ".tex");	strcpy(slog, ".ulf");	strcpy(addpath, "pdflatex");	break;

		case TOINF:	strcpy(suff, ".texi");	strcpy(slog, ".uli");	strcpy(addpath, "texinfo");		break;
		case TOMAN:	strcpy(suff, ".1");		strcpy(slog, ".ulm");	strcpy(addpath, "manpage");		break;
		case TOSTG:	strcpy(suff, ".stg");	strcpy(slog, ".uls");	strcpy(addpath, "stguide");		break;
		case TOAMG:	strcpy(suff, ".guide");	strcpy(slog, ".ulg");	strcpy(addpath, "amguide");		break;
		case TOPCH:	strcpy(suff, ".scr");	strcpy(slog, ".ulp");	strcpy(addpath, "pchelp");		break;
		case TOTVH:	strcpy(suff, ".txt");	strcpy(slog, ".ult");	strcpy(addpath, "tvhelp");		break;
		case TOLDS:	strcpy(suff, ".sgml");	strcpy(slog, ".uls");	strcpy(addpath, "linuxdoc");	break;

		case TOAQV:	strcpy(suff, ".rtf");	strcpy(slog, ".ulq");	strcpy(addpath, "quickvw");		break;
		case TODRC:	strcpy(suff, ".drc");	strcpy(slog, ".uld");	strcpy(addpath, "drc");			break;
		case TOIPF:	strcpy(suff, ".ipf");	strcpy(slog, ".uli");	strcpy(addpath, "ipf");			break;
		case TOLYX:	strcpy(suff, ".lyx");	strcpy(slog, ".ull");	strcpy(addpath, "lyx");			break;
		case TONRO:	strcpy(suff, ".1");		strcpy(slog, ".uln");	strcpy(addpath, "nroff");		break;

		case TOSRC:	strcpy(suff, ".c");		strcpy(slog, ".ulc");	strcpy(addpath, "c");			break;
		case TOSRP:	strcpy(suff, ".pas");	strcpy(slog, ".ulp");	strcpy(addpath, "pascal");		break;
		case TOUDO:	strcpy(suff, ".udo");	strcpy(slog, ".ulu");	strcpy(addpath, "udo");			break;
		case TOKPS:	strcpy(suff, ".ps");	strcpy(slog, ".ulp");	strcpy(addpath, "ps");			break;

		default:	strcpy(suff, ".txt");	strcpy(slog, ".ula");	strcpy(addpath, "ascii");		break;
	}

	get_log_suffix(slog, m_format);

	strcpy(shyp, slog);	shyp[2]= 'h';
	strcpy(stre, slog);	stre[2]= 't';
	strcpy(smap, ".hpp");

	if (m_use_dir)
	{	strcat(path, addpath);
		strcat(path, "\\");
	}

	// destfile bestimmen
	strcpy(namlow, name);
	if (m_pActFD->DestLower)
	{	strlwr(namlow);
	}

	if (m_pActFD->DestSuf.GetLength()>0)
	{	strcpy(suff, m_pActFD->DestSuf);
	}

	sprintf(s, "%s%s%s%s", driv, path, namlow, suff);
	sl= strlen(s)+1;
	strcpy(m_file_dest.GetBuffer(sl+1), s);
	m_file_dest.ReleaseBuffer();

	// logfile bestimmen
	sprintf(s, "%s%s%s%s", driv, path, name, slog);
	sl= strlen(s)+1;
	strcpy(m_file_log.GetBuffer(sl+1), s);
	m_file_log.ReleaseBuffer();

	// hypfile bestimmen
	sprintf(s, "%s%s%s%s", driv, path, name, shyp);
	sl= strlen(s)+1;
	strcpy(m_file_hyp.GetBuffer(sl+1), s);
	m_file_hyp.ReleaseBuffer();

	// treefile bestimmen
	sprintf(s, "%s%s%s%s", driv, path, name, stre);
	sl= strlen(s)+1;
	strcpy(m_file_tree.GetBuffer(sl+1), s);
	m_file_tree.ReleaseBuffer();

	// UPR file bestimmen
	sprintf(s, "%s%s%s%s", driv, path, name, ".upr");
	sl= strlen(s)+1;
	strcpy(m_file_upr.GetBuffer(sl+1), s);
	m_file_upr.ReleaseBuffer();

	// mapfiles bestimmen
	sprintf(s, "%s%s%s%s", driv, path, name, ".hpp");
	sl= strlen(s)+1;
	strcpy(m_file_map_pas.GetBuffer(sl+1), s);
	m_file_map_pas.ReleaseBuffer();

	sprintf(s, "%s%s%s%s", driv, path, name, ".hpg");
	sl= strlen(s)+1;
	strcpy(m_file_map_gfa.GetBuffer(sl+1), s);
	m_file_map_gfa.ReleaseBuffer();

	sprintf(s, "%s%s%s%s", driv, path, name, ".hpb");
	sl= strlen(s)+1;
	strcpy(m_file_map_vb.GetBuffer(sl+1), s);
	m_file_map_vb.ReleaseBuffer();

	if (m_pActFD!=NULL)
	{	// Parameter-Datei #2 bestimmen
		if (m_pActFD->ParamSuf.GetLength()>0)
		{	strcpy(namlow, name);
			if (m_pActFD->ParamLower)
			{	strlwr(namlow);
			}
			sprintf(s, "%s%s%s%s", driv, path, namlow, m_pActFD->ParamSuf);
			sl= strlen(s)+1;
			strcpy(m_file_param.GetBuffer(sl+1), s);
			m_file_param.ReleaseBuffer();
		}
		// Parameter-Datei #2 bestimmen
		if (m_pActFD->Param2Suf.GetLength()>0)
		{	strcpy(namlow, name);
			if (m_pActFD->Param2Lower)
			{	strlwr(namlow);
			}
			sprintf(s, "%s%s%s%s", driv, path, namlow, m_pActFD->Param2Suf);
			sl= strlen(s)+1;
			strcpy(m_file_param2.GetBuffer(sl+1), s);
			m_file_param2.ReleaseBuffer();
		}
		// Ergebnis-Datei bestimmen
		if (m_pActFD->FinalSuf.GetLength()>0)
		{	strcpy(namlow, name);
			if (m_pActFD->FinalLower)
			{	strlwr(namlow);
			}
			sprintf(s, "%s%s%s%s", driv, path, namlow, m_pActFD->FinalSuf);
			sl= strlen(s)+1;
			strcpy(m_file_final.GetBuffer(sl+1), s);
			m_file_final.ReleaseBuffer();
		}
	}

	UpdateData(FALSE);
}


void CUdosh32Dlg::adjust_other_files()
{
	char driv[32], path[512], name[512], suff[512], namlow[512];
	char s[512], slog[8], shyp[8], stre[8];
	size_t sl;

	UpdateData(TRUE);
	format2pActFD();

	m_file_param= "";
	m_file_final= "";
	m_file_log= "";
	m_file_hyp= "";
	m_file_tree= "";

	fsplit(m_file_dest, driv, path, name, suff);
	get_log_suffix(slog, m_format);

	strcpy(shyp, slog);	shyp[2]= 'h';
	strcpy(stre, slog);	stre[2]= 't';

	// logfile bestimmen
	sprintf(s, "%s%s%s%s", driv, path, name, slog);
	sl= strlen(s)+1;
	strcpy(m_file_log.GetBuffer(sl+1), s);
	m_file_log.ReleaseBuffer();

	// hypfile bestimmen
	sprintf(s, "%s%s%s%s", driv, path, name, shyp);
	sl= strlen(s)+1;
	strcpy(m_file_hyp.GetBuffer(sl+1), s);
	m_file_hyp.ReleaseBuffer();

	// treefile bestimmen
	sprintf(s, "%s%s%s%s", driv, path, name, stre);
	sl= strlen(s)+1;
	strcpy(m_file_tree.GetBuffer(sl+1), s);
	m_file_tree.ReleaseBuffer();

	if (m_pActFD!=NULL)
	{	// Parameter-Datei bestimmen
		if (m_pActFD->ParamSuf.GetLength()>0)
		{	strcpy(namlow, name);
			if (m_pActFD->ParamLower)
			{	strlwr(namlow);
			}
			sprintf(s, "%s%s%s%s", driv, path, namlow, m_pActFD->ParamSuf);
			sl= strlen(s)+1;
			strcpy(m_file_param.GetBuffer(sl+1), s);
			m_file_param.ReleaseBuffer();
		}
		// Ergebnis-Datei bestimmen
		if (m_pActFD->FinalSuf.GetLength()>0)
		{	strcpy(namlow, name);
			if (m_pActFD->FinalLower)
			{	strlwr(namlow);
			}
			sprintf(s, "%s%s%s%s", driv, path, namlow, m_pActFD->FinalSuf);
			sl= strlen(s)+1;
			strcpy(m_file_final.GetBuffer(sl+1), s);
			m_file_final.ReleaseBuffer();
		}
	}

	UpdateData(FALSE);
}


void CUdosh32Dlg::adjust_buttons()
{
	char driv[32], path[512], name[512], suff[512];

	fsplit(m_app_udo, driv, path, name, suff);
	SetDlgItemText(IDC_EXEC_SOURCE, name);

	fsplit(m_edi_udo, driv, path, name, suff);
	SetDlgItemText(IDC_EDIT_SOURCE, name);
	SetDlgItemText(IDC_BUTTON_LOG, name);
	SetDlgItemText(IDC_BUTTON_HYP, name);
	SetDlgItemText(IDC_BUTTON_TREE, name);
	SetDlgItemText(IDC_BUTTON_UPR, name);
	SetDlgItemText(IDC_BUTTON_MAP_PAS, name);
	SetDlgItemText(IDC_BUTTON_MAP_VB, name);
	SetDlgItemText(IDC_BUTTON_MAP_GFA, name);

	if (m_pActFD!=NULL)
	{
		fsplit(m_pActFD->DestApp, driv, path, name, suff);		SetDlgItemText(IDC_EXEC_DEST, name);
		fsplit(m_pActFD->DestEdi, driv, path, name, suff);		SetDlgItemText(IDC_EDIT_DEST, name);
		fsplit(m_pActFD->ParamApp, driv, path, name, suff);		SetDlgItemText(IDC_EXEC_PARAM, name);
		fsplit(m_pActFD->ParamEdi, driv, path, name, suff);		SetDlgItemText(IDC_EDIT_PARAM, name);
		fsplit(m_pActFD->Param2App, driv, path, name, suff);	SetDlgItemText(IDC_EXEC_PARAM2, name);
		fsplit(m_pActFD->Param2Edi, driv, path, name, suff);	SetDlgItemText(IDC_EDIT_PARAM2, name);
		fsplit(m_pActFD->FinalApp, driv, path, name, suff);		SetDlgItemText(IDC_EXEC_FINAL, name);
		fsplit(m_pActFD->FinalEdi, driv, path, name, suff);		SetDlgItemText(IDC_EDIT_FINAL, name);
	}
	else
	{
		strcpy(name, "");
		SetDlgItemText(IDC_EXEC_DEST, name);
		SetDlgItemText(IDC_EDIT_DEST, name);
		SetDlgItemText(IDC_EXEC_PARAM, name);
		SetDlgItemText(IDC_EDIT_PARAM, name);
		SetDlgItemText(IDC_EXEC_FINAL, name);
		SetDlgItemText(IDC_EDIT_FINAL, name);
	}

}


void CUdosh32Dlg::OnCheckDir() 
{
	adjust_files();
	adjust_buttons();
}


void CUdosh32Dlg::OnButtonInfo() 
{
	CAboutDlg dlg;
	dlg.m_version= __UDOVERSION__;	// in udosh32.h definiert
	dlg.DoModal();
}

void CUdosh32Dlg::OnButtonHelp() 
{
	WinHelp(NULL, HELP_CONTENTS);
	//AfxGetApp()->WinHelp(HID_MYTOPIC);
}

void CUdosh32Dlg::OnButtonConfig() 
{
	CConfigDlg dlg;

	dlg.m_dest_unix=	m_pActFD->DestUnix;
	dlg.m_dest_lower=	m_pActFD->DestLower;
	dlg.m_dest_suffix=	m_pActFD->DestSuf;

	dlg.m_param_unix=	m_pActFD->ParamUnix;
	dlg.m_param_lower=	m_pActFD->ParamLower;
	dlg.m_param_suffix=	m_pActFD->ParamSuf;

	dlg.m_param2_unix=		m_pActFD->Param2Unix;
	dlg.m_param2_lower=		m_pActFD->Param2Lower;
	dlg.m_param2_suffix=	m_pActFD->Param2Suf;

	dlg.m_final_unix=	m_pActFD->FinalUnix;
	dlg.m_final_lower=	m_pActFD->FinalLower;
	dlg.m_final_suffix=	m_pActFD->FinalSuf;

	if (dlg.DoModal()==IDOK)
	{
		m_pActFD->DestUnix=		dlg.m_dest_unix;
		m_pActFD->DestLower=	dlg.m_dest_lower;
		m_pActFD->DestSuf=		dlg.m_dest_suffix;

		m_pActFD->ParamUnix=	dlg.m_param_unix;
		m_pActFD->ParamLower=	dlg.m_param_lower;
		m_pActFD->ParamSuf=		dlg.m_param_suffix;

		m_pActFD->Param2Unix=	dlg.m_param2_unix;
		m_pActFD->Param2Lower=	dlg.m_param2_lower;
		m_pActFD->Param2Suf=	dlg.m_param2_suffix;

		m_pActFD->FinalUnix=	dlg.m_final_unix;
		m_pActFD->FinalLower=	dlg.m_final_lower;
		m_pActFD->FinalSuf=		dlg.m_final_suffix;

		adjust_files();
	}
}

void CUdosh32Dlg::OnSelendokComboFormat() 
{
	adjust_files();
	adjust_buttons();
}


void CUdosh32Dlg::OnCheckAot() 
{
	UpdateData(TRUE);

	if (m_always_on_top)
	{
		SetWindowPos(&wndTopMost, -1, -1, -1, -1, SWP_NOMOVE | SWP_NOSIZE);
	}
	else
	{
		SetWindowPos(&wndNoTopMost, -1, -1, -1, -1, SWP_NOMOVE | SWP_NOSIZE);
	}
}

